#ifndef __DSDB_SAMDB_SAMDB_PROTO_H__
#define __DSDB_SAMDB_SAMDB_PROTO_H__

#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2) PRINTF_ATTRIBUTE(a1, a2)
/* This file was automatically generated by mkproto.pl. DO NOT EDIT */

/* this file contains prototypes for functions that are private 
 * to this subsystem or library. These functions should not be 
 * used outside this particular subsystem! */


/* The following definitions come from dsdb/samdb/samdb.c  */

char *samdb_relative_path(struct ldb_context *ldb,
				 TALLOC_CTX *mem_ctx, 
				 const char *name) ;
struct cli_credentials *samdb_credentials(struct tevent_context *event_ctx, 
					  struct loadparm_context *lp_ctx) ;
struct ldb_context *samdb_connect(TALLOC_CTX *mem_ctx, 
				  struct tevent_context *ev_ctx,
				  struct loadparm_context *lp_ctx,
				  struct auth_session_info *session_info);

/****************************************************************************
 Create the SID list for this user.
****************************************************************************/
NTSTATUS security_token_create(TALLOC_CTX *mem_ctx, 
			       struct tevent_context *ev_ctx, 
			       struct loadparm_context *lp_ctx,
			       struct dom_sid *user_sid,
			       struct dom_sid *group_sid, 
			       int n_groupSIDs,
			       struct dom_sid **groupSIDs, 
			       bool is_authenticated,
			       struct security_token **token);

/* The following definitions come from dsdb/samdb/samdb_privilege.c  */

struct ldb_context *privilege_connect(TALLOC_CTX *mem_ctx, 
				      struct tevent_context *ev_ctx,
				      struct loadparm_context *lp_ctx);
NTSTATUS samdb_privilege_setup(struct tevent_context *ev_ctx, 
			       struct loadparm_context *lp_ctx, struct security_token *token);

/* The following definitions come from dsdb/samdb/cracknames.c  */

WERROR DsCrackNameOneName(struct ldb_context *sam_ctx, TALLOC_CTX *mem_ctx,
			  uint32_t format_flags, uint32_t format_offered, uint32_t format_desired,
			  const char *name, struct drsuapi_DsNameInfo1 *info1);
NTSTATUS crack_user_principal_name(struct ldb_context *sam_ctx, 
				   TALLOC_CTX *mem_ctx, 
				   const char *user_principal_name, 
				   struct ldb_dn **user_dn,
				   struct ldb_dn **domain_dn) ;
NTSTATUS crack_service_principal_name(struct ldb_context *sam_ctx, 
				      TALLOC_CTX *mem_ctx, 
				      const char *service_principal_name, 
				      struct ldb_dn **user_dn,
				      struct ldb_dn **domain_dn) ;
NTSTATUS crack_name_to_nt4_name(TALLOC_CTX *mem_ctx, 
				struct tevent_context *ev_ctx, 
				struct loadparm_context *lp_ctx,
				uint32_t format_offered,
				const char *name, 
				const char **nt4_domain, const char **nt4_account);
NTSTATUS crack_auto_name_to_nt4_name(TALLOC_CTX *mem_ctx,
				     struct tevent_context *ev_ctx, 
				     struct loadparm_context *lp_ctx,
				     const char *name,
				     const char **nt4_domain,
				     const char **nt4_account);

/* The following definitions come from dsdb/repl/replicated_objects.c  */

WERROR dsdb_extended_replicated_objects_convert(struct ldb_context *ldb,
						const char *partition_dn,
						const struct drsuapi_DsReplicaOIDMapping_Ctr *mapping_ctr,
						uint32_t object_count,
						const struct drsuapi_DsReplicaObjectListItemEx *first_object,
						uint32_t linked_attributes_count,
						const struct drsuapi_DsReplicaLinkedAttribute *linked_attributes,
						const struct repsFromTo1 *source_dsa,
						const struct drsuapi_DsReplicaCursor2CtrEx *uptodateness_vector,
						const DATA_BLOB *gensec_skey,
						TALLOC_CTX *mem_ctx,
						struct dsdb_extended_replicated_objects **objects);
WERROR dsdb_extended_replicated_objects_commit(struct ldb_context *ldb,
					       struct dsdb_extended_replicated_objects *objects,
					       uint64_t *notify_uSN);
WERROR dsdb_origin_objects_commit(struct ldb_context *ldb,
				  TALLOC_CTX *mem_ctx,
				  const struct drsuapi_DsReplicaObjectListItem *first_object,
				  uint32_t *_num,
				  struct drsuapi_DsReplicaObjectIdentifier2 **_ids);
#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2)

#endif /* __DSDB_SAMDB_SAMDB_PROTO_H__ */

