#ifndef __LIB_SOCKET_NETIF_PROTO_H__
#define __LIB_SOCKET_NETIF_PROTO_H__

#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2) PRINTF_ATTRIBUTE(a1, a2)
/* This file was automatically generated by mkproto.pl. DO NOT EDIT */

/* this file contains prototypes for functions that are private 
 * to this subsystem or library. These functions should not be 
 * used outside this particular subsystem! */


/* The following definitions come from lib/socket/interface.c  */


/**
load the list of network interfaces
**/
void load_interfaces(TALLOC_CTX *mem_ctx, const char **interfaces, struct interface **local_interfaces);

/**
  how many interfaces do we have
  **/
int iface_count(struct interface *ifaces);

/**
  return IP of the Nth interface
  **/
const char *iface_n_ip(struct interface *ifaces, int n);

/**
  return bcast of the Nth interface
  **/
const char *iface_n_bcast(struct interface *ifaces, int n);

/**
  return netmask of the Nth interface
  **/
const char *iface_n_netmask(struct interface *ifaces, int n);

/**
  return the local IP address that best matches a destination IP, or
  our first interface if none match
*/
const char *iface_best_ip(struct interface *ifaces, const char *dest);

/**
  return true if an IP is one one of our local networks
*/
bool iface_is_local(struct interface *ifaces, const char *dest);

/**
  return true if a IP matches a IP/netmask pair
*/
bool iface_same_net(const char *ip1, const char *ip2, const char *netmask);

/* The following definitions come from lib/socket/netif.c  */


/****************************************************************************
 Get the netmask address for a local interface.
****************************************************************************/
int get_interfaces(struct iface_struct *ifaces, int max_interfaces);
#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2)

#endif /* __LIB_SOCKET_NETIF_PROTO_H__ */

