#ifndef __LIBCLI_SECURITY_PROTO_H__
#define __LIBCLI_SECURITY_PROTO_H__

#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2) PRINTF_ATTRIBUTE(a1, a2)
/* This file was automatically generated by mkproto.pl. DO NOT EDIT */

/* this file contains prototypes for functions that are private 
 * to this subsystem or library. These functions should not be 
 * used outside this particular subsystem! */


/* The following definitions come from libcli/security/security_token.c  */

struct security_token *security_token_initialise(TALLOC_CTX *mem_ctx);

/****************************************************************************
 prints a struct security_token to debug output.
****************************************************************************/
void security_token_debug(int dbg_lev, const struct security_token *token);
bool security_token_is_sid(const struct security_token *token, const struct dom_sid *sid);
bool security_token_is_sid_string(const struct security_token *token, const char *sid_string);
bool security_token_is_system(const struct security_token *token) ;
bool security_token_is_anonymous(const struct security_token *token) ;
bool security_token_has_sid(const struct security_token *token, const struct dom_sid *sid);
bool security_token_has_sid_string(const struct security_token *token, const char *sid_string);
bool security_token_has_builtin_administrators(const struct security_token *token);
bool security_token_has_nt_authenticated_users(const struct security_token *token);
bool security_token_has_enterprise_dcs(const struct security_token *token);
enum security_user_level security_session_user_level(struct auth_session_info *session_info) ;

/* The following definitions come from libcli/security/access_check.c  */

NTSTATUS sec_access_check(const struct security_descriptor *sd, 
			  const struct security_token *token,
			  uint32_t access_desired,
			  uint32_t *access_granted);
NTSTATUS sec_access_check_ds(const struct security_descriptor *sd,
			     const struct security_token *token,
			     uint32_t access_desired,
			     uint32_t *access_granted,
			     struct object_tree *tree,
			     struct dom_sid *replace_sid);

/* The following definitions come from libcli/security/privilege.c  */

const char *sec_privilege_name(enum sec_privilege privilege);
const char *sec_privilege_display_name(enum sec_privilege privilege, uint16_t *language);
enum sec_privilege sec_privilege_id(const char *name);
bool security_token_has_privilege(const struct security_token *token, enum sec_privilege privilege);
void security_token_set_privilege(struct security_token *token, enum sec_privilege privilege);
void security_token_debug_privileges(int dbg_lev, const struct security_token *token);

/* The following definitions come from libcli/security/sddl.c  */

struct security_descriptor *sddl_decode(TALLOC_CTX *mem_ctx, const char *sddl,
					const struct dom_sid *domain_sid);
char *sddl_encode(TALLOC_CTX *mem_ctx, const struct security_descriptor *sd,
		  const struct dom_sid *domain_sid);

/* The following definitions come from libcli/security/create_descriptor.c  */

uint32_t map_generic_rights_ds(uint32_t access_mask);
struct security_descriptor *create_security_descriptor(TALLOC_CTX *mem_ctx,
						       struct security_descriptor *parent_sd,
						       struct security_descriptor *creator_sd,
						       bool is_container,
						       struct GUID *object_list,
						       uint32_t inherit_flags,
						       struct security_token *token,
						       struct dom_sid *default_owner, /* valid only for DS, NULL for the other RSs */
						       struct dom_sid *default_group, /* valid only for DS, NULL for the other RSs */
						       uint32_t (*generic_map)(uint32_t access_mask));

/* The following definitions come from libcli/security/object_tree.c  */

bool insert_in_object_tree(TALLOC_CTX *mem_ctx,
			  const struct GUID *guid,
			  uint32_t init_access,
			  struct object_tree **root,
			  struct object_tree **new_node);
struct object_tree *get_object_tree_by_GUID(struct object_tree *root,
					     const struct GUID *guid);
void object_tree_modify_access(struct object_tree *root,
			       uint32_t access);
#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2)

#endif /* __LIBCLI_SECURITY_PROTO_H__ */

